create_gate_frame<-function(frame,flowframe=NULL,inputfile=NULL,popdesc=NULL,guiframe=NULL)
{

    

    file=inputfile
    pops_names<-NULL
    if (!is.null(popdesc)) frame$gate_frame$pop_desc<-read.table(file=popdesc,header=TRUE)
    if (!is.null(popdesc)) pops_names<-frame$gate_frame$pop_desc
    timestamp()
    data<-NULL
    gate_frame<-frame$gate_frame
    if (!is.null(gate_frame)){
        struct<-gate_frame$struct
        data<-gate_frame$data
    }

    if (!is.null(struct)){
        scatters<-struct$scatters
        alexas<-struct$alexas
        pacific<-struct$pacific
        pe<-struct$pe
    }
    if (is.null(scatters$def)) sc_def<-c(FALSE,FALSE) else sc_def<-scatters$def
    if (!is.null(inputfile)) data<-NULL
    scat_cl<-NULL

    if (!is.null(file)){
        fil_nb<-length(file)
        if (fil_nb>1){
            for (i in 1:fil_nb){
                serv<-read.FCS(file[i])

                if (!is.null(serv@description$SPILL)) serv<-compensate(serv,spillover=serv@description$SPILL)

                serv<-serv@exprs
                scat_cl<-c(scat_cl,rep(i,nrow(serv)))

                data<-rbind(data,serv)

            }
        } else {
            data<-read.FCS(file)
            if (!is.null(data@description$SPILL)) data<-compensate(data,spillover=data@description$SPILL)
            data<-data@exprs
        }
    }



    if (!is.null(guiframe) & !is.null(scat_cl)) stop("cluster ids for scatters already defined")

    if (!is.null(guiframe)){
        gate_frame<-gui_creation(data)
        if (!is.null(gate_frame)){
            struct<-gate_frame$struct
        }
    }

    if (!is.null(flowframe)) data<-flowframe@exprs

    if (is.null(scatters) | is.null(alexas) | is.null(pacific) | is.null(data)) stop("necessary input not supplied!")


    matfl<-prepare_flow_data(mat=data,scatters=scatters$names,
                             dims1=alexas$names,
                             dims2=pacific$names,PE=pe,scat_def=sc_def)

    if (is.null(scat_cl)) scat_cl<-divide_scatters(matfl[,scatters$names],ddiv1=scatters$ddiv1,ddiv2=scatters$ddiv2
                                                   ,show=F)

    cl<-rep(0,nrow(matfl))
    scsel<-sort(unique(scat_cl[which(scat_cl>0)]))
    shift<-length(scsel)
    nbsc<-shift
    for (i in sort(scsel)){
        sel<-which(scat_cl==i)
        print("clustering population ('scatters')")
        print(i)
        alex_cl<-divide_hist_comb(matfl[sel,alexas$names],alexas$struct[[i]],heur=FALSE)
        cl[sel]<-alex_cl$clusterid
        alexas_s<-alexas$struct[[i]]
        cl[sel]<-enumerate(alex_cl$med,alexas$struct[[i]],cl[sel])

        if (FALSE){
            coo=alex_cl$med
            col=rep(1,nrow(matfl[sel,]))
            col[which(cl[sel]==5)]<-4
            plot(matfl[sel,alexas$names],col=col)

            text(coo[,1],coo[,2],as.character(sort(unique(cl[sel]))))
            readline()
        }


    }

    cl_f<-rep(0,nrow(matfl))
                                        #Odsad je to uplne blbe!!!!!! Uz opraveno, ale jeste se na to mrknout!
    for (j in 1:nbsc){

        scat_sel=which(scat_cl==j)
        alex_loc<-cl[scat_sel]
        cl_f_loc<-rep(0,length(scat_sel))
        mat_loc<-matfl[scat_sel,]
        forsel=sort(unique(alex_loc))
        print("clustering 'pacifics' in 'scatter':")
        print(j)

        for (i in forsel){
            print("population:")
            print(i)
            stid=which(pacific$struct[[j]]$miss[1,]==i)
            if (length(stid)==1) {
                pacific_s<-list(base=pacific$struct[[j]]$base,
                                miss=pacific$struct[[j]]$miss[2:nrow(pacific$struct[[j]]$miss),stid])
                pacific_s$miss<-pacific_s$miss[which(pacific_s$miss>0)]
            }else{
                pacific_s<-list(base=pacific$struct[[j]]$base,miss=pacific$struct[[j]]$missd)
            }

            nbpop=pacific_s$base[1]*pacific_s$base[2]-length(pacific_s$miss)

            clf<-cluster_kmedoids(mat_loc[which(alex_loc==i),pacific$names],nbpop,show=F,id=i)
            coo<-clf$med
            clf$clusterid<-enumerate(clf$med,pacific_s,clf$clusterid)

            cl_f_loc[which(alex_loc==i)]<-clf$clusterid
        }

        cl_f[scat_sel]<-cl_f_loc
    }


    timestamp()

    return(list(gate_frame=list(data=data,struct=struct,cluster_sc=scat_cl,cluster_al=cl,
                  cluster_pop=cl_f,pop_desc=pops_names),template=NULL))
}

inspect_gate_frame<-function(frame,inputfile=NULL)
{
    file=inputfile
    temp_sav<-frame$template
    gate_frame<-frame$gate_frame
    structure<-gate_frame$struct
    if (!is.null(file)){
        if (is.null(frame$template)) stop("The frame looks like a pre-frame")
        new_exp<-apply_gate_template(frame,file=file)
        gate_frame$cluster_sc<-new_exp$cluster_sc
        gate_frame$cluster_al<-new_exp$cluster_al
        gate_frame$cluster_pop<-new_exp$cluster_pop
        gate_frame$data<-read.FCS(file)
        if (!is.null(gate_frame$data@description$SPILL)) gate_frame$data<-compensate(gate_frame$data,spillover=gate_frame$data@description$SPILL)@exprs

    }
    scat_cl<-gate_frame$cluster_sc
    alexa_cl<-gate_frame$cluster_al
    pop_cl<-gate_frame$cluster_pop


    mat<-gate_frame$data

    order="nic"
    alexas<-structure$alexas
    scatters<-structure$scatters
    pacific<-structure$pacific
    pe<-structure$pe
    if (is.null(scatters$def)) sc_def<-c(FALSE,FALSE) else sc_def<-scatters$def
    
    matfl<-prepare_flow_data(mat=mat,scatters=scatters$names,
                             dims1=alexas$names,dims2=pacific$names,PE=pe,scat_def=sc_def)
    while (order!="ok" & order!="quit"){
        matt<-mat[,structure$scatters$names]
        matt[which(matt<0)]<- -1* matt[which(matt<0)]
        col<-scat_cl
        
        col[which((col %% 8) ==1)]<-6
        col[which((col %% 8) ==7)]<-5
        col[which(col==0)]<-1
        if (nrow(matt)>0) plot(log10(matt),col=col,pch=".")
        print("(ok) for accepting clusters, (quit) for leaving inspectation,(i)nteractive mode")
        med=NULL
        for (ii in sort(unique(scat_cl[which(scat_cl>0)]))){
            if (length(which(scat_cl==ii))>1){

                med=rbind(med,apply(log10(matt[which(scat_cl==ii),]),MARGIN=2,median))
            } else med=rbind(med,log10(matt[which(scat_cl==ii),]))
        }
        if (length(unique(scat_cl[which(scat_cl>0)]))) text(med[,1],med[,2],structure$beadsize[(sort(unique(scat_cl[which(scat_cl>0)])))])
        order<-readline()
        names<-structure$scatters$names

        popnb<-sum(structure$scatters$div2)

        if (order=="i"){
            print("gate (m)anualy")
            order<-readline()
            if (order=="m"){
#####################################################################################
                manual<-cluster_manual(mat[,c(names,frame$gate_frame$struct$pe)],scat_cl,popnb)
                scat_cl<-manual$cluster
                change<-manual$change

                for (sc_i in unique(change)){

                    sel<-which(scat_cl==sc_i)

                    print("re-clustering alexas")
                    alex_cl<-divide_hist_comb(matfl[sel,alexas$names],alexas$struct[[sc_i]],heur=FALSE)
                    alexa_cl[sel]<-alex_cl$clusterid

                    alexa_cl[sel]<-enumerate(alex_cl$med,alexas$struct[[sc_i]],alexa_cl[sel])
                    for (al_i in sort(unique(alexa_cl[sel]))){
                        print("re-clustering population:")
                        print(al_i)
                        re_pop<-gate_pop(matfl[sel,],pacific$struct[[sc_i]],al_i,alexa_cl[sel],pacific$names)
                        pop_cl[which((scat_cl==sc_i) & (alexa_cl==al_i))]<-re_pop$cluster
                    }


                }
#####################################################################################
            }
        }else if (order=="r"){

        }
    }

    if (order=="quit") {
        template=temp_sav
        return(invisible(list(gate_frame=gate_frame,template=template)))
    }

                                        #--------jen provizorne-------------
    order<-"nic"
    sc_sel<- sort(unique(scat_cl[which(scat_cl>0)]))
    sc_i<-1
    while (order!="ok" & order!="quit"){
        print("beadsize:")
        print(structure$beadsize[sc_i])
        sel<-which(scat_cl==sc_i)
        if (length(sel)>1){
            matt<-mat[sel,structure$alexas$names]
            matt[which(matt<0)]<- -1* matt[which(matt<0)]
            col<-alexa_cl[sel]
            al_cl<-alexa_cl[sel]
            col[which((col %% 8) ==1)]<-6
            col[which((col %% 8) ==7)]<-5
            col[col==0]<-1
            
            plot(log10(matt),col=col,pch=".",cex=3)
            
            print("(ok) for accepting clusters, (quit) for laving inspectation without changes, (n)ext beadsize, (b) for former beasize,(i)nteractive mode")
            med=NULL
            for (ii in sort(unique(al_cl[which(al_cl>0)]))){
                if (length(which(al_cl==ii))>1){
                    med=rbind(med,apply(log10(matt[which(al_cl==ii),]),MARGIN=2,median))
                } else med=rbind(med,log10(matt[which(al_cl==ii),]))
            }
            if (length(unique(al_cl[which(al_cl>0)]))) text(med[,1],med[,2],as.character(sort(unique(al_cl[which(al_cl>0)]))))
        } else print("no events in this beadsize")
        order<-readline()
        names<-structure$alexas$names
        popnb<-structure$alexas$struct[[sc_i]]$base[1]*structure$alexas$struct[[sc_i]]$base[2]-length(structure$alexas$struct[[sc_i]]$miss)
        if (order=="i"){
            print("gate (m)anualy")
            order<-readline()
            if (order=="m"){
#####################################################################################
                manual<-cluster_manual(mat[sel,c(names,frame$gate_frame$struct$pe)],alexa_cl[sel],popnb)
                alexa_cl[sel]<-manual$cluster
                change<-manual$change
                alexas<-structure$alexas
                scatters<-structure$scatters
                pacific<-structure$pacific
                pe<-structure$pe

                for (al_i in unique(change)){

                    print("re-clustering population:")
                    print(al_i)
                    re_pop<-gate_pop(matfl[sel,],pacific$struct[[sc_i]],al_i,alexa_cl[sel],pacific$names)
                    pop_cl[which((scat_cl==sc_i) & (alexa_cl==al_i))]<-re_pop$cluster
                }



#####################################################################################
            }
        }
        if ((order=="n") & (sc_sel[sc_i]<max(sc_sel))) sc_i=sc_i+1
        if ((order=="b") & (sc_sel[sc_i]>min(sc_sel))) sc_i=sc_i-1

    }

    if (order=="quit") {
        template=temp_sav
        return(invisible(list(gate_frame=gate_frame,template=template)))
    }

                                        #--------------jen provizorne---------------------------------

    scat_id=1
    i=1
    order<-"nic"
    al_id<-sort(unique(alexa_cl[which(scat_cl==scat_id & alexa_cl>0)]))
    s_clm<-NULL
    while (order != "quit" & order != "finish"){
###############################################################
        print("beadsize")
        print(structure$beadsize[scat_id])
        print("alexa population:")
        print(al_id[i])

        sel=which(scat_cl==scat_id & alexa_cl==al_id[i])


        names<-structure$pacific$names
###############################################################
        if (length(sel)>1){
            cl_loc<-pop_cl[sel]
            matt<-mat[sel,names]
            print("hu")
            
            matt[which(matt<0)]<- -1* matt[which(matt<0)]
            col<-cl_loc
            print(sort(unique(col)))
            col[which((col %% 8) ==1)]<-6
            col[which((col %% 8) ==7)]<-3
            col[which(col==0)]<-1
            col[which(col<0)]<-1
            ## image(xcuts,sort(ycuts),matrix(imcol[,1],64,64,byrow=T))
            ## readline()
            plot(log10(matt),col=col,pch=".",cex=3)
            ## abline(v=xcuts,lwd=0.2,col="lightgrey")
            ## abline(h=ycuts,lwd=0.2,col="lightgrey")
            

            med=NULL

            for (ii in sort(unique(cl_loc[which(cl_loc>0)]))){
                if (length(which(cl_loc==ii))>1){
                    med=rbind(med,apply(log10(matt[which(cl_loc==ii),]),MARGIN=2,median))
                } else{ med=rbind(med,log10(matt[which(cl_loc==ii),]))
                    }
            }
            if (length(which(cl_loc>0))) text(med[,1],med[,2],as.character(sort(unique(cl_loc[which(cl_loc>0)]))))
        } else print("no events in this population")

        popnb<-structure$pacific$struct[[scat_id]]$base[1]*structure$pacific$struct[[scat_id]]$base[2]
        print(" (i)nteractive mode, (quit) without saving, (finish) save and quit, (save) your current work")
        print("(n)ext population in this beadsize, (nn)ext beadsize")
        print("(b)ack, (bb)ack")

        order<-readline()

        if (order=="save"){

            gate_frame$cluster_pop<-pop_cl
            gate_frame$cluster_sc<-scat_cl
            gate_frame$cluster_al<-alexa_cl
            print("saving frame in the file 'quickedsavedframe'...")
            quicksavedframe=list(gate_frame=gate_frame,template=NULL)
            save(quicksavedframe,file="quicksavedframe")
        }
        if (order=="i"){
            print("mi(s)sing population, (r)e-enumerate, (b)atch re-enumeration or gate (m)anualy")
            order<-readline()
            if (order=="m"){
#####################################################################################
                pop_cl[sel]<-cluster_manual(mat[sel,c(names,frame$gate_frame$struct$pe,frame$gate_frame$struct$alexas$names)],pop_cl[sel],popnb)$cluster
#####################################################################################
            }else if (order=="s"){

                nb<-NULL
                print("indicate nbs of missing population a finish by typing 'do' or (q)uit without saving")
                r<-"nic"
                while (r != "do" & r!="q"){
                    r<-readline()
                    if (!is.na(as.numeric(r))) nb<-c(nb,r)
                }
                if (r=="do"){
                    b<-gate_frame$struct$pacific$struct[[scat_id]]$base
                    matmiss<-gate_frame$struct$pacific$struct[[scat_id]]$miss
                    if (!(any(matmiss[1,]==al_id[i]))){
                        matmiss<-cbind(matmiss,matrix(0,b[1]*b[2]+1,1))
                        matmiss[1,ncol(matmiss)]<-al_id[i]
                    }

                    if (!is.null(nb)){
                        nb<-unique(nb)
                        matmiss[2:(length(matmiss[,1])),which(matmiss[1,]==al_id[i])]<-0
                        matmiss[2:(length(nb)+1),which(matmiss[1,]==al_id[i])]<-as.numeric(nb)
                        gate_frame$struct$pacific$struct[[scat_id]]$miss<-matmiss


                        k_number<-b[1]*b[2]-length(nb)
                        edited_sel<-sel[which(pop_cl[sel]>-1)]
                        cl_miss<-cluster_kmedoids(matfl[edited_sel,names],k_number,show=F,id=i)

                        cl_miss<-enumerate(cl_miss$med,list(base=b,miss=as.numeric(nb)),cl_miss$clusterid) #porad blbe opravit!!!!!!!!!

                    } else {
                        edited_sel<-sel[which(pop_cl[sel]>-1)]
                        matmiss[2:(length(matmiss[,1])),which(matmiss[1,]==al_id[i])]<-0
                        cl_miss<-cluster_kmedoids(matfl[edited_sel,names],b[1]*b[2],show=F,id=i) #-----provizorne, nefunguje
                        cl_miss<-enumerate(cl_miss$med,list(base=b,miss=NULL),cl_miss$clusterid)
                    }
                    pop_cl[edited_sel]<-cl_miss

                }

            }else if (order=="r"){
                b<-gate_frame$struct$pacific$struct[[scat_id]]
                cl<-which(b$miss[1,]==al_id[i])
                n_miss=NULL
                if (length(cl>0)) n_miss<-b$miss[2:(length(which(b$miss[,cl]>0))),cl]
                pop<-b$base[1]*b$base[2]
                tab<-matrix(0,pop-length(n_miss),2)
                index_m<-1:pop
                if (length(n_miss)>0) index_m<-index_m[-n_miss]
                tab[,1]<-index_m
                tab[,2]<-index_m
                if (!is.null(s_clm) & length(s_clm)==pop & length(tab[,1])==pop) tab[,2]<-s_clm

                colnames(tab)<-c("Old","New")
                tab<-as.data.frame(tab)
                tab<-edit(tab)
                s_clm<-tab[,2]
                popp<-pop_cl[sel]

                for (iii in tab[,1]){
                    popp[which(pop_cl[sel]==iii)]<-tab[which(tab[,1]==iii),2]
                }
                pop_cl[sel]<-popp
            } else if (order=="b"){
                b<-gate_frame$struct$pacific$struct[[scat_id]]$base
                coc<-NULL
                mat_loc_en<-matfl[sel,names]
                for (q in sort(unique(pop_cl[sel][pop_cl[sel]>0]))){
                    coc=rbind(coc,apply(mat_loc_en[which(pop_cl[sel]==q),],MARGIN=2,median))
                }
                coco<-coc
                ref<-al_id[i]
                ## print(coc)
                ## trans1<-approxfun(coc[,1],rep(coc[13:16,1],4),rule=2)
                ## ## trans2<-approxfun(coc[,2],rep(coc[c(1,5,9,13),2],4),rule=2)
                ## coc1<-trans1(coc[,1])
                ## ## coc2<-trans2(coc[,2])
                ## ## par(mfrow=c(2,1))
                ## ## plot(coc)
                ## ## text(coc[,1],coc[,2],as.character(1:16))

                ## coco[,1]<-coc1
                ## ## coc[,2]<-coc2
                ## ## plot(coco)
                ## ## text(coco[,1],coco[,2],as.character(1:16))
                ## ## par(mfrow=c(1,1))
                ## ## readline()
                ## pop_cl[sel]<-enumerate1(coco,list(base=b,miss=0),pop_cl[sel]) ## nula
                for (ii in sort(unique(alexa_cl[alexa_cl>0 & alexa_cl!=ref]))){
                    
                    print(ii)
                    print("aaaaaaaaaaaaaaaaaaaa")
                    sel_en=which(scat_cl==scat_id & alexa_cl==ii)
                    coc<-NULL
                    mat_loc_en<-matfl[sel_en,names]
                    for (q in sort(unique(pop_cl[sel_en][pop_cl[sel_en]>0]))){
                        coc=rbind(coc,apply(mat_loc_en[which(pop_cl[sel_en]==q),names],MARGIN=2,median))
                    }
                    ## uz to nejde.......
                    pop_loc_en<-pop_cl[sel_en]
                    min<-rep(0,nrow(coco))
                    for (r in 1:nrow(coco)){
                        
                        min[r]<-t(coco[r,]-coc[r,])%*%(coco[r,]-coc[r,])
                    }
                    print(min)
                    dist<-matrix(0,ncol=nrow(coco),nrow=nrow(coc))
                    for (q in 1:nrow(coco))
                        for (r in 1:nrow(coc))
                            dist[r,q]<-(coc[r,]-coco[q,])%*%(coc[r,]-coco[q,])
                    
                    for (r in 1:nrow(coc)){
                        print(r)
                        print(which.min(dist[r,]))
                        print("---------------------")
                        pop_loc_en[pop_cl[sel_en]==r]<-which.min(dist[r,])
                    }
                    pop_cl[sel_en]<-pop_loc_en
                    
                }
                
            }

        }
#####################################################################################
        if (order=="n" & al_id[i]<max(al_id)) i=i+1
        if (order=="nn" & scat_id<max(scat_cl)){
            scat_id=scat_id+1
            al_id<-sort(unique(alexa_cl[which(scat_cl==scat_id & alexa_cl>0)]))
            i=1

        }
        if (order=="b" & i>1) i=i-1
        if (order=="bb" & scat_id>1){
            scat_id=scat_id-1
            al_id<-sort(unique(alexa_cl[which(scat_cl==scat_id & alexa_cl>0)]))
            i=1
        }
        if (order=="" & (al_id[i]<max(al_id))) i=i+1
#####################################################################################

    }

    if (order == "finish"){
        gate_frame$cluster_pop<-pop_cl
        gate_frame$cluster_sc<-scat_cl
        gate_frame$cluster_al<-alexa_cl

        print("creating default percentile vector")
        perc_pop<-NULL
        scsel<-sort(unique(scat_cl[which(scat_cl>0)]))
        for (i in scsel){
            alsel<-sort(unique(alexa_cl[which(scat_cl==i)]))
            for (j in alsel){
                popsel<-sort(unique(pop_cl[which(scat_cl==i & alexa_cl==j)]))
                for (k in popsel){
                    perc_pop<-c(perc_pop,length(pop_cl[which(scat_cl==i & alexa_cl==j & pop_cl==k)])/length(scat_cl[which(scat_cl>0)]))

                }
            }
        }

        print("preparing flow data")
        mat<-prepare_flow_data(mat=mat,scatters=gate_frame$struct$scatters$names,
                               dims1=gate_frame$struct$alexas$names,
                               dims2=gate_frame$struct$pacific$names,PE=gate_frame$struct$pe,scat_def=sc_def)


        template<-list(scatters=NULL,alexas=NULL,pacific=NULL,perc_pop=perc_pop)
        l<-length(unique(scat_cl[which(scat_cl>0)]))

        pattern<-create_pattern(mat=mat[,gate_frame$struct$scatters$names],nbins=64)

        print("assigning scatters")


        if (any(structure$scatters$def)) depth=1 else depth=6
        assign<-assign_pattern(mat=mat[,gate_frame$struct$scatters$names],pattern=pattern,neib=TRUE,clusterid=scat_cl,cut_level=3,depth=depth,scat=TRUE)
        template$scatters<-list(pat=pattern,ass=assign)
        template$alexas<-list()[rep(1:l)]
        template$pacific<-list()[rep(1:l)]


        for (i in 1:l){
            print("assigning alexas")
            sel=which(scat_cl==i)
            pattern<-create_pattern(mat=mat[sel,gate_frame$struct$alexas$names],nbins=64)
            assign<-assign_pattern(mat=mat[sel,gate_frame$struct$alexas$names],pattern=pattern,neib=TRUE,clusterid=alexa_cl[sel],cut_level=4,depth=3,scat=TRUE)
            template$alexas[[i]]<-list(pat=pattern,ass=assign)
            pattern<-create_pattern(mat=mat[sel,gate_frame$struct$pacific$names],nbins=64)
            template$pacific[[i]]<-list(pat=pattern,ass=NULL)
            al_id<- sort(unique(alexa_cl[which(scat_cl==i & alexa_cl>0)]))
            ass_mat<-matrix(0,64^2,length(al_id))
            k=1

            print("assigning pacifics")
            for (j in al_id){
                sel_a<-which(scat_cl==i & alexa_cl==j)
                pat_p<-template$pacific[[i]]$p
                ass_mat[,k]<-assign_pattern(mat=mat[sel_a,gate_frame$struct$pacific$names],pattern=pat_p,neib=TRUE,clusterid=pop_cl[sel_a],cut_level=2,depth=6,inf=j)
                k=k+1
            }
            template$pacific[[i]]$ass<-ass_mat
        }


    }


    if (order=="quit") template=temp_sav

    return(invisible(list(gate_frame=gate_frame,template=template)))

}



apply_gate_template<-function(frame=NULL,directory=NULL,file=NULL,experiment_destination=NULL,outputfile=NULL,tube="well",qc=TRUE,despikify=TRUE,mininfo=NULL,nb_frac=24,meanvar=FALSE)
{
    a<-NULL
    experiment<-experiment_destination
    if (is.null(experiment)) experiment<-"."
    if (!is.null(outputfile)) experiment<-NULL

    if (is.null(frame)){

        if (substr(x=directory,start=nchar(directory),stop=nchar(directory))=="/") directory_n=substr(x=directory,start=1,stop=nchar(directory)-1) else directory_n<-directory
        print(directory)
        files<-system(paste ("ls"," ",directory,sep=""), intern=T)
        a<-grep(".txt",files,perl=T)
        files<-files[-a]
        frame_load<-load(paste(directory_n,"/",files[grep("array",files,perl=T)],sep=""))

        frame<-get(frame_load)
    }
    
    if (is.null(mininfo) & !is.null(directory) & (length(a)>0)) mininfo<-system(paste("ls"," ",directory_n,"/", "*.txt",sep=""),intern=T)
    if (!is.null(experiment)) if (substr(x=experiment,start=nchar(experiment),stop=nchar(experiment))=="/") experiment=substr(x=experiment,start=1,stop=nchar(experiment)-1)
    if (is.null(directory)) qc<-FALSE
    if (is.null(directory)) meanvar<-FALSE
    if (!is.null(mininfo)){
        mininfo<-read_mininfo(mininfo)
        ## mininfo<-read.table(mininfo,sep="\t",fill=T)[1:14,1:4]
        print(mininfo$table)
       
    }

    warningfile<-NULL
    laser_shift<-NULL
    if (is.null(frame$gate_frame)) stop("No information in the frame")
    if (is.null(frame$template)) stop("No template in the frame")
    filename<-outputfile
    s_names<-frame$gate_frame$struct$beadsize
    old<-getwd()
    if (is.null(file) & is.null(directory)) stop("apply on what??")
    if (is.null(file)){

        setwd(directory)
        ls<-system("ls",intern=T)} else ls=file


    non_fcs<-which(substr(ls,nchar(ls)-2,nchar(ls))!="fcs" & substr(ls,nchar(ls)-2,nchar(ls))!="FCS")
    if (length(non_fcs)>0) ls<-ls[-non_fcs]

    scat<-frame$gate_frame$struct$scatters
    alex<-frame$gate_frame$struct$alexas
    pac<-frame$gate_frame$struct$pacific
    pe<-frame$gate_frame$struct$pe
    if (is.null(scat$def)) sc_def<-c(FALSE,FALSE) else sc_def<-scat$def
    temp_sc<-frame$template$scatters
    temp_alex<-frame$template$alexas
    temp_pacific<-frame$template$pacific
    medians<-list(NULL)[rep(1:length(unique(temp_sc$ass[which(temp_sc$ass>0)])))]
    med_pop<-list(NULL)[rep(1:length(unique(temp_sc$ass[which(temp_sc$ass>0)])))]
    pop_len<-list(NULL)[rep(1:length(unique(temp_sc$ass[which(temp_sc$ass>0)])))]
    unimod<-list(NULL)[rep(1:length(unique(temp_sc$ass[which(temp_sc$ass>0)])))]
    meanvar_m<-list(NULL)[rep(1:length(unique(temp_sc$ass[which(temp_sc$ass>0)])))]
    meanvar_v<-list(NULL)[rep(1:length(unique(temp_sc$ass[which(temp_sc$ass>0)])))]
    header<-NULL


    file_nb<-0

    for (i in 1:length(medians)){
        n_pop_pac<-pac$struct[[i]]$base[1]*pac$struct[[i]]$base[2]*alex$struct[[i]]$base[1]*alex$struct[[i]]$base[2]
        medians[[i]]<-matrix(1,n_pop_pac,length(ls)) #zmeneno na 1 z -1
        pop_len[[i]]<-matrix(-1,n_pop_pac,length(ls))
        meanvar_v[[i]]<-meanvar_m[[i]]<-matrix(-1,n_pop_pac,length(ls))
        unimod[[i]]<-matrix(1,n_pop_pac,length(ls))
        med_pop[[i]]<-c(1:n_pop_pac)
    }
    timestamp()
    for (name in ls){
        file_nb=file_nb+1
        print(name)
        fcs<-read.FCS(file=name)
        if (!is.null(fcs@description$SPILL)) fcs<-compensate(fcs,spillover=fcs@description$SPILL)
        fcs_header<-fcs
        data_for_prep<-fcs@exprs
        if (tube=="well") fcs<-fcs@description$`WELL ID` else fcs<-fcs@description$`TUBE NAME`

        header<-c(header,fcs)
        
        matfl<-prepare_flow_data(mat=data_for_prep,scatters=scat$names,
                                 dims1=alex$names,
                                 dims2=pac$names,PE=pe,scat_def=sc_def)

        temp<-create_template(ass=temp_sc$ass, pattern= temp_sc$pat)

        scat_cl<-assign_events(mat=matfl[,scat$names],template=temp)$clusterid
        if (length(scat_cl)>0) err_ratio<-length(which(scat_cl>0))/length(scat_cl) else err_ratio=0
        if (err_ratio<0.8)  warningfile<-rbind(warningfile,data.frame(filename=name,sc="ALL",alexa="ALL",pacifics="ALL",ratio=err_ratio))
        alex_cl<-rep(0,nrow(matfl))
        pop_cl<-alex_cl
        pop_cl_file<-pop_cl

        for (i in sort(unique(temp_sc$ass[which(temp_sc$ass>0)]))){
            sel=which(scat_cl==i)

            temp<-create_template(ass=temp_alex[[i]]$ass, pattern= temp_alex[[i]]$pat)
            if (length(sel)>1) alex_cl[sel]<-assign_events(mat=matfl[sel,alex$names],template=temp)$clusterid
            if (length(alex_cl[sel])>0) err_ratio<-length(which(alex_cl[sel]>0))/length(alex_cl[sel]) else err_ratio=0
            if (err_ratio<0.8) warningfile<-rbind(warningfile,data.frame(filename=name,sc=s_names[i],alexa="ALL",pacifics="ALL",ratio=err_ratio))
            k=1
            alex_nb<-length(unique(temp_alex[[i]]$ass[which(temp_alex[[i]]$ass>0)]))
            for (j in sort(unique(temp_alex[[i]]$ass[which(temp_alex[[i]]$ass>0)]))){
                sel1=which(scat_cl==i & alex_cl==j)
                if (length(sel1)>1){
                    temp<-create_template(ass=temp_pacific[[i]]$ass[,k], pattern= temp_pacific[[i]]$pat)
                    doc<-assign_events(mat=matfl[sel1,pac$names],template=temp)$clusterid

                    if (j==(alex_nb %/% 2 -1)){
                        mat_cor<-matfl[sel1,pac$names]
                        sel21=which(frame$gate_frame$cluster_sc==i & frame$gate_frame$cluster_al==j)
                        mat_orig_test<-prepare_flow_data(mat=frame$gate_frame$data[sel21,],scatters=scat$names,
                                                         dims1=alex$names,
                                                         dims2=pac$names,PE=pe,scat_def=sc_def)[,pac$names]
                        if (mean(mat_cor[,1],trim=0.05)-mean(mat_orig_test[,1],trim=0.05)>0.2){
                            if (nchar(strsplit(name,"/[^/]+$"))!=nchar(name)) name_n<-substr(name,nchar(strsplit(name,"/[^/]+$"))+2,nchar(name)) else name_n<-name
                            laser_shift<-rbind(laser_shift,c(i,name_n,fcs,pac$names[1]))
                        }

                        if (mean(mat_cor[,2],trim=0.05)-mean(mat_orig_test[,2],trim=0.05)>0.2){
                            if (nchar(strsplit(name,"/[^/]+$"))!=nchar(name)) name_n<-substr(name,nchar(strsplit(name,"/[^/]+$"))+2,nchar(name)) else name_n<-name
                            laser_shift<-rbind(laser_shift,c(i,name_n,fcs,pac$names[2]))
                        }
                        
                        
                    }
                    pop_cl_file[sel1]<-doc
                    if (length(doc)>0) err_ratio<-length(which(doc>0))/length(doc) else err_ratio=0
                    if (err_ratio<0.8){
                        warningfile<-rbind(warningfile,data.frame(filename=name,sc=s_names[i],alexa=as.character(j),pacifics="ALL",ratio=err_ratio))

                    }
                    doc[which(doc>0)]<-doc[which(doc>0)]+pac$struct[[i]]$base[1]*pac$struct[[i]]$base[2]*(j-1)
                    pop_cl[sel1]<-doc
                }
                k=k+1

            }

            med<-extract_median(clusterid=pop_cl[sel],mat=matfl[sel,pe],show=F,def_perc=frame$template$perc_pop,qc=qc,meanvar=meanvar)
            ##blbost na kvadrat!! Vyplod silence!!!
            if (length(med[2,]>0)) medians[[i]][med[2,],file_nb]<-med[1,]

            if (length(med[2,]>0)) pop_len[[i]][med[2,],file_nb]<-med[3,]

            if (length(med[2,]>0)) unimod[[i]][med[2,],file_nb]<-med[4,]

            if (length(med[2,]>0)) meanvar_m[[i]][med[2,],file_nb]<-med[5,]

            if (length(med[2,]>0)) meanvar_v[[i]][med[2,],file_nb]<-med[6,]
        }


    }
    medians_all<-NULL
    med_pop_all<-NULL
    pop_len_all<-NULL
    unimod_all<-NULL
    meanvar_v_all<-meanvar_m_all<-NULL
    if (!qc) despikify<-FALSE

    if (!is.null(directory)){
        for (i in sort(unique(temp_sc$ass[which(temp_sc$ass>0)]))){

            ord<-order(header)
            medians_all<-rbind(medians_all,medians[[i]][,ord])
            unimod_all<-rbind(unimod_all,unimod[[i]][,ord])
            meanvar_v_all<-rbind(meanvar_v_all,meanvar_v[[i]][,ord])
            meanvar_m_all<-rbind(meanvar_m_all,meanvar_m[[i]][,ord])
            med_pop_all<-c(med_pop_all,med_pop[[i]])
            medians[[i]]<-cbind(med_pop[[i]],medians[[i]][,ord])
            medians[[i]]<-rbind(c("pop",header[ord]),medians[[i]])
            pop_len[[i]]<-pop_len[[i]]

            pop_len_all<-rbind(pop_len_all,pop_len[[i]][,ord])


        }
        if (is.null(frame$gate_frame$pop_desc)) pop_len_all<-cbind(med_pop_all,cbind(med_pop_all,cbind(med_pop_all,pop_len_all))) else pop_len_all<-cbind(frame$gate_frame$pop_desc,pop_len_all)

        colnames(medians_all)<-header[ord]
        if (!is.null(laser_shift)) header_tube<-header
        if (!is.null(mininfo)){

            nb_samp<-ncol(medians_all)%/% nb_frac

            header<-NULL
            for (i in 1:nb_samp){
                header<-c(header,paste(rep((mininfo$desc[paste("sample",i,sep="_")]),nb_frac),1:nb_frac,sep="_"))
                

            }
            if (!is.null(laser_shift)){
                rr<-NULL
                for (i in 1:nrow(laser_shift)){
                    rr<-c(rr,header[which(header_tube==laser_shift[i,4])])
                }
                laser_shift<-cbind(laser_shift,rr)
                
            }

            colnames(medians_all)<-header


        }

        pop_len_all<-pop_len_all[,-c(1,2)]


        if (!is.null(mininfo)) colnames(pop_len_all)<-c("pop",header) else colnames(pop_len_all)<-c("pop",header[ord])

        if (!is.null(frame$gate_frame$pop_desc)) medians_all<-cbind(frame$gate_frame$pop_desc[,c(3,1,2)],medians_all) else
        medians_all<-cbind(med_pop_all,cbind(med_pop_all,cbind(med_pop_all,medians_all)))
        unimod_all<-data.frame(pop_len_all[,1],unimod_all)
        meanvar_m_all<-data.frame(pop_len_all[,1],meanvar_m_all)
        meanvar_v_all<-data.frame(pop_len_all[,1],meanvar_v_all)
        colnames(meanvar_m_all)<-colnames(meanvar_v_all)<-colnames(unimod_all)<-colnames(pop_len_all)


        qc_all<-rbind(pop_len_all,unimod_all,meanvar_m_all,meanvar_v_all)


        if (despikify){
            medians_all_desp<-medians_all[,-c(1,2,3)]
            qc_loc<-qc_all[,-1]
            medians_loc<-medians_all[,-c(1,2,3)]

            for (i in 1:ncol(medians_loc)){
                for (j in 1:nrow(medians_loc)){
                    if (i %% 24!=0 & i %% 24!=1){
                        if ((qc_loc[j,i]<8 | qc_loc[(nrow(medians_loc)+j),i]<0) & !((qc_loc[j,i-1]<8 | qc_loc[(nrow(medians_loc)+j),i-1]<0)
                                                                                    | (qc_loc[j,i+1]<8 | qc_loc[(nrow(medians_loc)+j),i+1]<0)))
                            medians_all_desp[j,i]<-(medians_loc[j,(i-1)]+medians_loc[j,(i+1)])/2} else
                    if (qc_loc[j,i]<8 | qc_loc[(nrow(medians_loc)+j),i]<0)
                        if (i %% 24 ==1) medians_all_desp[j,i]<-medians_all_desp[j,i+1] else medians_all_desp[j,i]<-medians_all_desp[j,i-1]
                }
            }
            medians_all_desp<-cbind(medians_all[,c(1,2,3)],medians_all_desp)
            rm(qc_loc,medians_loc)

        }

        if (!is.null(filename)){
            write.table(x=medians_all,file=paste(filename,"_","all",".txt",sep=""),row.names=FALSE,col.names=TRUE,sep="\t")
            write.table(file=paste(filename,"_","popsize","_","all",".txt",sep=""),x=pop_len_all,col.names=TRUE,row.names=FALSE)
            write.table(file=paste(filename,"_","qc","_","all",".txt",sep=""),x=qc_all,col.names=TRUE,row.names=FALSE)
        }
    }

    if (!is.null(experiment) & !is.null(directory)){


        if (!is.null(mininfo)) {
            experiment_n<-paste(mininfo$desc["pltID"],mininfo$desc["exp"],sep="_")
            experiment<-paste(experiment,"/",experiment_n,sep="")


        } else if (nchar(strsplit(experiment,"/[^/]+$"))!=nchar(experiment)) experiment_n<-substr(experiment,nchar(strsplit(experiment,"/[^/]+$"))+2,nchar(experiment)) else experiment_n<-experiment
        print(experiment)
        setwd(old)
        create_directory_structure(experiment)
        write.table(x=medians_all,file=paste(experiment,"/","MEDS","/",paste(mininfo$desc["pltID"],substr(x=mininfo$desc["exp"],start=1,stop=7), "MEDIANS",sep="_"),".txt",sep=""),row.names=FALSE,col.names=TRUE,sep="\t")
        write.table(file=paste(experiment,"/","QC","/",paste(experiment_n, "qc",sep="_"),".txt",sep=""),x=qc_all,col.names=TRUE,row.names=FALSE)
        if (!is.null(mininfo)) write.table(file=paste(experiment,"/","INFO","/",paste(experiment_n,"MININFO",sep="_"),".txt",sep=""),x=mininfo$table,col.names=FALSE,row.names=FALSE,sep="\t")
        save(file=paste(experiment,"/","INFO","/",paste(experiment_n, "frame",sep="_"),sep=""),x=frame)
        if (despikify) write.table(x=medians_all_desp,file=paste(experiment,"/","MEDS","/",paste(mininfo$desc["pltID"],substr(x=mininfo$desc["exp"],start=1,stop=7), "MEDIANS_DESP",sep="_"),".txt",sep=""),row.names=FALSE,col.names=TRUE,sep="\t")




    }

    if(is.null(file) & is.null(experiment)){

    }
    timestamp()


    if (length(warningfile)>0) {
        print("FCS file(s) with less than 80% events gated, warnings listed in the file warning.err in working directory")
        if (!is.null(experiment) & !is.null(directory))  write.table(warningfile,file=paste(experiment,"/","QC","/warningfile.err",sep=""),row.names=F)
        else write.table(warningfile,file="warningfile.err",row.names=F)
    }

    if (!is.null(laser_shift)) {
        print("Laser shift warning")
        if (!is.null(experiment) & !is.null(directory))  write.table(laser_shift,file=paste(experiment,"/","QC","/laser_shift.err",sep=""),row.names=F,col.names=F)
        else write.table(laser_shift,file="laser_shift.err",row.names=F,col.names=F)
    }
    setwd(old)
    if (!is.null(file)){
        return(invisible(list(cluster_pop=pop_cl_file, cluster_sc=scat_cl, cluster_al=alex_cl)))
    }



}
create_directory_structure<-function(exp_name)
{
    system(paste("mkdir"," ",exp_name,sep=""))
    system(paste("mkdir"," ", exp_name,"/","MEDS",sep=""))
    system(paste("mkdir"," ", exp_name,"/","QC",sep=""))
    system(paste("mkdir"," ", exp_name,"/","INFO",sep=""))
    system(paste("mkdir"," ", exp_name,"/","FCS",sep=""))
    system(paste("mkdir"," ", exp_name,"/","ANALYSIS",sep=""))

}



plot_lineplots<-function(experiment=NULL,inputfile=NULL,pdfoutput=NULL,nb_fr=24,log=TRUE,fixedlimits=TRUE,nogrid=FALSE,selection=NULL,pop_sel=NULL,medians=NULL,mininfo=NULL,qc_file=NULL,peaks=NULL)

{
    if (!is.null(experiment)) if (substr(x=experiment,start=nchar(experiment),stop=nchar(experiment))=="/") experiment=substr(x=experiment,start=1,stop=nchar(experiment)-1)
    selected_pop<-NULL
    qc_data=NULL
    matt<-NULL
    mat_desp<-NULL
    if (!is.null(experiment)){

        if (nchar(strsplit(experiment,"/[^/]+$"))!=nchar(experiment)) experiment_n<-substr(experiment,nchar(strsplit(experiment,"/[^/]+$"))+2,nchar(experiment)) else experiment_n<-experiment

        if (!is.null(mininfo)) {
            experiment_n<-paste(mininfo$desc["pltID"],substr(x=mininfo$desc["exp"],start=1,stop=7),sep="_")
            experiment<-paste(experiment,"/",experiment_n,sep="")

        }

        qc_ls<-system(paste("ls"," ",experiment,"/","QC","/",sep=""),intern=TRUE)
        info_ls<-system(paste("ls"," ",experiment,"/","INFO","/",sep=""),intern=TRUE)
        meds_ls<-system(paste("ls"," ",experiment,"/","MEDS","/",sep=""),intern=TRUE)
        if (paste(experiment_n, "MININFO.txt",sep="_") %in% info_ls){
            mininfo<-read_mininfo(paste(experiment,"/","INFO","/",paste(experiment_n,"MININFO.txt",sep="_"),sep=""))
             experiment_n<-paste(mininfo$desc["pltID"],substr(x=mininfo$desc["exp"],start=1,stop=7),sep="_")
        }
        mat<-read.table(paste(experiment,"/","MEDS","/",paste(experiment_n, "MEDIANS.txt",sep="_"),sep=""),header=TRUE,stringsAsFactors=F)
        if (paste(experiment_n,"MEDIANS_DESP.txt",sep="_") %in% meds_ls)  mat_desp<-read.table(paste(experiment,"/","MEDS","/",paste(experiment_n,"MEDIANS_DESP.txt",sep="_"),sep=""),header=TRUE,stringsAsFactors=F)[,-c(1,2,3)]

        if (paste(mininfo$desc["pltID"],mininfo$desc["exp"], "qc.txt",sep="_") %in% qc_ls) qc_data<-read.table(paste(experiment,"/","QC","/",paste(mininfo$desc["pltID"],mininfo$desc["exp"], "qc.txt",sep="_"),sep=""),header=T,stringsAsFactors=F)[,-1]
        system(paste("mkdir"," ",experiment,"/","ANALYSIS/LINEPLOTS",sep=""))
        pdfoutput<-paste(experiment,"/","ANALYSIS/LINEPLOTS","/",paste(experiment_n,"lineplot.pdf",sep="_"),sep="")
        pdfoutput_d<-paste(experiment,"/","ANALYSIS/LINEPLOTS","/",paste(experiment_n,"lineplot_desp.pdf",sep="_"),sep="")
        pop_desc<-mat[,c(1,2,3)]
        popnames<-mat[,c(3,1)]
        mat<-mat[,-c(1,2,3)]


    } else {
        if (!is.null(mininfo)) mininfo<-read_mininfo(mininfo)
        if (is.null(inputfile)) stop("no data to plot")
        if (is.null(pdfoutput)) stop("name of pdf file not given")


        for (inpf in inputfile){
            mat<-read.table(inpf,header=TRUE,stringsAsFactors=F)
            pop_desc<-mat[,c(1,2,3)]
            popnames<-mat[,c(3,1)]
            mat<-mat[,-c(1,2,3)]
            if (length(matt)>0) matt<-cbind(matt,mat) else matt<-mat
        }
        mat<-matt
        if (!is.null(qc_file)) qc_data<-read.table(qc_file,header=T,stringsAsFactors=F)[,-1]

    }
    if (!is.null(pop_sel)) {

        pop_sel<-read.table(pop_sel,header=TRUE,stringsAsFactors=F)
        for (i in 1:nrow(pop_sel)){

                                        #            selected_pop<-c(selected_pop,which(pop_sel[i,1]==pop_desc[,2] & pop_sel[i,2]==pop_desc[,3]))
            selected_pop<-c(selected_pop,grep(pop_sel[i,3],pop_desc[,1],fixed=TRUE))
        }
    }

    if (!is.null(selected_pop)){
        mat<-mat[selected_pop,]
        popnames<-popnames[selected_pop,]
        if (!is.null(medians)) write.table(rbind(popnames[selected_pop,],mat),file=medians,row.names=FALSE,col.names=TRUE,sep="\t")
    }
    sel<-NULL
    for (i in selection) sel<-c(sel,c(((i-1)*nb_fr+1):((i-1)*nb_fr+nb_fr)))
    if (!is.null(sel)) mat<-mat[,sel]

    if (ncol(mat) %% nb_fr !=0) stop ("number of tubes is not a multiple of number of fractions")

    line_plot(matrix=mat,nb_fr=nb_fr,filepdf=pdfoutput,popnames=popnames,log=log,fixed=fixedlimits,nogrid=nogrid,mininfo=mininfo,qc_data=qc_data,peaks=peaks)
    if (!is.null(mat_desp)) line_plot(matrix=mat_desp,nb_fr=nb_fr,filepdf=pdfoutput_d,popnames=popnames,log=log,fixed=fixedlimits,nogrid=nogrid,mininfo=mininfo,qc_data=qc_data)

}

prepare_flow_data<-function(file=NULL,mat=NULL,scatters,dims1,dims2,PE,scat_def=c(FALSE,FALSE))
{
    if (is.null(file) && is.null(mat)){
        
        print("No data given")
        return(0)
    }

    if (!is.null(file)){
        flfm<-read.FCS(file)
        if (!is.null(flfm@description$SPILL)) flfm<-compensate(flfm,spillover=flfm@description$SPILL)
        mat<-flfm@exprs
    }
    scat_to_zero<-scatters[which(scat_def==TRUE)]

    if (length(scat_to_zero)>1) if (any(mat[,scat_to_zero]<0)) mat[which(mat[,scat_to_zero]<0,T)[,1],scat_to_zero]<-0  #mozna dat nuly vsude?
    if (length(scat_to_zero)==1) if (any(mat[,scat_to_zero]<0)) mat[which(mat[,scat_to_zero]<0),scat_to_zero]<-0  #mozna dat nuly vsude?
    if (any(mat<0))  mat[which(mat<0)]<- -1.0*mat[which(mat<0)]
                                        #    if (any(mat==0))  mat[which(mat==0)]<- mat[which(mat==0)]+0.001 #asi zbytecny
    
    mat<-mat[,c(scatters,dims1,dims2,PE)]
    n=nrow(mat[,c(dims1,dims2)])
    m=ncol(mat[,c(scatters,dims1,dims2)])
    fj<-.C("transform",mv=as.double(mat[,c(scatters,dims1,dims2)]),as.integer(n),as.integer(m),as.double(1000.0),PACKAGE="rgbeads")
    mat_p<-matrix(fj$mv,nrow=n,ncol=m)
    mat[,c(scatters,dims1,dims2)]<-mat_p
    return(mat)


}
adjacency_matrix<-function(mat,mode=0)
{
    n=nrow(mat)
    m=ncol(mat)
    nbV=n*m



    fk<-.C("nbnonzero",as.integer(n),as.integer(m),k=integer(1),hash=integer(nbV*3),as.integer(mode),PACKAGE="rgbeads")
    fj<-.C("nonzero",i1=integer(fk$k),j1=integer(fk$k),as.integer(n),as.integer(m),as.integer(fk$hash),as.integer(mode),PACKAGE="rgbeads")
    i1<-fj$i1
    j1<-fj$j1
    adj1<-Matrix::spMatrix(nbV,nbV,i=i1,j=j1,x=rep(1,length(i1)))
    return(list(hash=matrix(fk$hash,3,nbV,byrow=T),mat=adj1))
}

adjacency_vector<-function(vect)
{
    n=length(vect)

    value <- diag(rep(1,n), n, n)

    R <- row(value)
    C <- col(value)
    value[C == R + 1] <- rep(1,n-1)
    value[C == R - 1] <- rep(1,n-1)
    ii<-which(value>0,T)[,1]
    jj<-which(value>0,T)[,2]
    value<-Matrix::spMatrix(n,n,i=ii,j=jj,x=rep(1,length(jj)))

    return(value)
}

divide_scatters<-function(mat,ddiv1,ddiv2,show=FALSE)
{

    cl<-rep(0,nrow(mat))
    res<-divide_hist1d(mat,ddiv1,ddiv2)$clusterid
    for (i in unique(res)){
        sel<-which(res==i)
        res_m<-mat[sel,]
        res_c<-flowClust(res_m,K=1,level=0.98)
        if (show){
            plot(res_c,data=mat)
            readline()
        }
        cl[sel[res_m %in% res_c]]<-i

    }
    return(cl)
}

divide_hist1d<-function(mat,ddiv1,ddiv2,nbbreaks=50)
{
    cl<-rep(0,nrow(mat))

    cl_p<-divide_one_d(1,ddiv1,mat,nbbreaks)
    jj<-0
    for (i in 1:ddiv1){

        cl[which(cl_p==i)]<-divide_one_d(2,ddiv2[i],mat[which(cl_p==i),],nbbreaks)+jj
        jj<-jj+ddiv2[i]

    }

    med=NULL

    for (i in sort(unique(cl[which(cl>0)]))){
        med=rbind(med,apply(mat[which(cl==i),],MARGIN=2,median))
    }


    return(list(clusterid=cl,med=med))

}

divide_one_d<-function(dim,ddiv,matt,nbbreaks,heur=FALSE)
{

    cl_p<-rep(1,nrow(matt))
    if (ddiv==1) return(cl_p)
    his<-hist(matt[,dim],breaks=nbbreaks,plot=F)
    nb<-length(his$counts)
    koef=0.8
    adj<-adjacency_vector(rep(0,nb))
    len_comp=0
    while ((koef>0.2) & (len_comp != ddiv) ){
        prel<-max(his$counts)*koef #mozna tu volbu predelat uplne
        koef<-0.8*koef
        susp<-which(his$counts>prel)
        adj_n<-adj[susp,susp]
        gr<-graph.adjacency(adj_n,mode="undirected")
        V(gr)$index<-susp
        comp<-decompose.graph(gr)
        len_comp<-length(comp)
        if (length(comp)==ddiv){
            i=0
            br1<-rep(0.0,ddiv-1)
            while (i<ddiv-1){
                i=i+1
                zac=V(comp[[i]])[max(V(comp[[i]]))]$index
                kon=V(comp[[i+1]])[0]$index

                d<-which(his$counts[zac:kon]==
                         min(his$counts[zac:kon]))+zac-1
                if (heur) if (min(his$counts[zac:kon])>0) return(NULL)
                br1[i]<-mean(his$breaks[c(d,d+1)])



            }
            i=1
            while (i < ddiv){
                cl_p[which(matt[,dim]>br1[i])]<-i+1
                i=i+1
            }

        }
    }
    if (len_comp != ddiv) {
        if (heur) return(NULL)
        print(length(comp))
        print("Unable to identify appropriate number of population... dividing by quantiles")
        ord<-order(matt[,dim])
        L<-length(ord) %/% ddiv
        i=1
        while (i <= ddiv){
            cl_p[ord[((i-1)*L+1 ):(i*L)]]<-i
            i=i+1
        }

    }

    return(cl_p)
}

cluster_manual<-function(mat,cl,pop_nb)
{

    cl_ch=NULL

    if (any(mat<0))  mat[which(mat<0)]<- -1.0*mat[which(mat<0)]
    if (any(mat==0))  mat[which(mat==0)]<- mat[which(mat==0)]+0.001
    mat<-(log10(mat))
    cl_loc<-cl



    col<-cl_loc
    col[which((col %% 8) == 1)]<-6
    col[which((col %% 8) ==7)]<-5
    col[which(col==0)]<-1
    col[which(col<0)]<-1
    colg<- (col %% 7)+1

    rg<-ggobi(mat)
    glyph_color(rg$mat)<-colg
    glyph_size(rg$mat)<-1
    d<-displays(rg)[[1]]
    imode(d)<-"Brush"

    print("(q)uit without saving, (sq) save and quit")
    print("Select population and assign number (type (u) for unmark events):")
    a="a"
    while (a != "sq" & a !="q"){

        plot(mat,col=col)
        med=NULL
        for (i in sort(unique(cl_loc[which(cl_loc>0)]))){
            if (length(which(cl_loc==i))>1){

                med=rbind(med,apply(mat[which(cl_loc==i),],MARGIN=2,median))
            } else med=rbind(med,mat[which(cl_loc==i),])
        }

        if (length(which(cl_loc>0))>0) text(med[,1],med[,2],as.character(sort(unique(cl_loc[which(cl_loc>0)]))))
        a<-readline()

        if (a != "sq" & a !="q" ){
            if (a=="u"){
                glyph_color(rg$mat)<-colg
            } else
            {
                a<-as.numeric(a)

                if (!is.na(a)) {

                    if (a!=0) cl_ch<-c(cl_ch,a)
                                        #            print(glyph_color(rg$mat))
                    sel<-which(glyph_color(rg$mat)==9)
                    print(a)
                    cl_loc[which(cl_loc==a)]=0
                    cl_loc[sel]<-a
                    col<-cl_loc
                    col[which((col %% 8) == 1)]<-6
                    col[which(col==0)]<-1
                    col[which(col<0)]<-1
                    colg<- (col %% 7)+1
                    glyph_color(rg$mat)<-colg



                } else a=""
            }
        }

    }
    close.GGobi(rg)

    if (a == "sq") cl<-cl_loc else cl_ch<-NULL

    return(list(cluster=cl,change=cl_ch))

}

cluster_kmedoids<-function(mat,nb,show=F,id)
{
    mmat<-t(solve(cov(mat),t(mat)))
    cl<-pam(mmat,nb,stand=T,cluster.only=TRUE)

    med=NULL
    for (i in sort(unique(cl[which(cl>0)]))){

        med=rbind(med,apply(mat[which(cl==i),],MARGIN=2,median))
    }

    return(list(clusterid=cl,med=med))
}


hist2d_eval<-function (x, y = NULL, nbins = 64, na.rm=TRUE)
{
    if (is.null(y)) {
        if (ncol(x) != 2)
            stop("If y is ommitted, x must be a 2 column matrix")
        y <- x[, 2]
        x <- x[, 1]
    }
    if (length(nbins) == 1)
        nbins <- rep(nbins, 2)
    nas <- is.na(x) | is.na(y)
    if (na.rm) {
        x <- x[!nas]
        y <- y[!nas]
    }
    else stop("missing values not permitted if na.rm=FALSE")
    x.cuts <- seq(from = min(x), to = max(x), length = nbins[1] + 1,labels=F)
    y.cuts <- seq(from = max(y), to = min(y), length = nbins[2] + 1,labels=F)

    index.x <- cut(x, x.cuts, include.lowest = TRUE,labels=F)
    index.y <- cut(y, y.cuts, include.lowest = TRUE,labels=F)
    m <- matrix(0, nrow = nbins[1], ncol = nbins[2])
    for (i in 1:length(index.x)) m[index.x[i], index.y[i]] <- m[index.x[i],
                                                                index.y[i]] + 1
    xvals <- x.cuts[1:nbins[1]]
    yvals <- y.cuts[1:nbins[2]]


    return(list(counts = m, x = xvals, y = yvals,xi=index.x,yi=index.y))
}

divide_hist_comb<-function(mat,struct,nbins=64,heur=FALSE)
{

    nbbreaks=50
    dim1<-struct$base[1]
    dim2<-struct$base[2]
    missing<-struct$miss
    nbcl<-dim1*dim2-length(missing)
    if (heur){

        ddiv1<-rep(dim2,dim1)
        ddiv2<-rep(dim1,dim2)
        for (i in missing){
            ind1=i %% dim1
            ind2=i %/% dim1 + 1
            if ((i %% dim1)==0) ind2=ind2-1

            if (ind1==0) ind1=dim1
            ddiv1[ind1]=ddiv1[ind1]-1
            ddiv2[ind2]=ddiv2[ind2]-1

        }

        cl<-rep(0,nrow(mat))
        samp<-get_representants(mat,nbins)
        ## plot(samp)
        ## readline()
        res=divide_one_d(1,dim1,samp,nbbreaks,heur=TRUE)
        cl_f<-rep(0,nrow(samp))
        if (!is.null(res)){
            j=0
            for (i in 1:dim1){
                samp_s<-samp[which(res==i),]
                cl_p<-pam(samp_s,k=ddiv1[i],cluster.only=TRUE,stand=F)+j
                cl_f[which(res==i)]<-cl_p
                j<-j+ddiv2[i]
            }
            resC<-.C("assign_nearest_s",as.double(mat),as.integer(nrow(mat)),as.integer(ncol(mat)),as.double(samp),
                     as.integer(nrow(samp)),as.integer(cl_f),result=as.integer(cl),PACKAGE="rgbeads")
            cl=resC$resul

            med=NULL
            for (i in sort(unique(cl[which(cl>0)]))){
                med=rbind(med,apply(mat[which(cl==i),],MARGIN=2,median))
            }
            return (list(clusterid=cl,med=med))
        }
        else{
            samp<-get_representants(mat,nbins)
            

            res=divide_one_d(2,dim2,samp,nbbreaks,heur=TRUE)
            if (!is.null(res)){
                j=0
                for (i in 1:dim2){
                    samp_s<-samp[which(res==i),]
                    cl_p<-pam(samp,k=ddiv2[i],cluster.only=TRUE,stand=F)+j

                    cl_f[which(res==i)]<-cl_p
                    j<-j+ddiv2[i]
                }

                resC<-.C("assign_nearest_s",as.double(mat),as.integer(nrow(mat)),as.integer(ncol(mat)),as.double(samp),
                         as.integer(nrow(samp)),as.integer(cl_f),result=as.integer(cl),PACKAGE="rgbeads")
                cl=resC$resul
                med=NULL
                for (i in sort(unique(cl[which(cl>0)]))){
                    med=rbind(med,apply(mat[which(cl==i),],MARGIN=2,median))
                }
                return (list(clusterid=cl,med=med))
            }
        }

    }
    result<-divide_hist2d(mat,nbcl)
    return(result)
}

divide_hist2d<-function(mat,nbcl,nbins=64)
{
    cl<-rep(0,nrow(mat))

    samp<-get_representants(mat,nbins)
    
    
    cl_p<-pam(samp,k=nbcl,cluster.only=TRUE,stand=F)
    
    ##  plot(samp)
    ## pdf("fig2-2.pdf")
    ## plot(samp,col=cl_p)
    ## dev.off()
    ## readline()


                                        #   res<-.C("assign_nearest",as.double(mat),as.integer(nrow(mat)),as.integer(ncol(mat)),as.double(cl_p$medoids),as.integer(nbcl),result=as.integer(cl),PACKAGE="rgbeads")
    res<-.C("assign_nearest_s",as.double(mat),as.integer(nrow(mat)),as.integer(ncol(mat)),as.double(samp),as.integer(nrow(samp)),as.integer(cl_p),result=as.integer(cl),PACKAGE="rgbeads")

    cl=res$resul
    med=NULL
    for (i in sort(unique(cl[which(cl>0)]))){

        med=rbind(med,apply(mat[which(cl==i),],MARGIN=2,median))
    }
    return(list(clusterid=cl,med=med))

}

get_representants<-function(mat,nbins)
{
    h2d<-hist2d_eval(mat,nbins=nbins)

    cutoff<-2*(nrow(mat) %/% (nbins^2)+1) #tady to muze byt citlive, myslim, ze muzu byt volnejsi

    sel<-which(h2d$counts>cutoff,T)

    ssize<-min(1000 %/% length(sel) + 2,cutoff)


    ssx=NULL
    for (i in 1:length(sel[,1])){

        ssx=c(ssx,which(h2d$xi==sel[i,1] & h2d$yi==sel[i,2])[1:ssize])
    }

    return(samp=mat[ssx,])
}

create_pattern<-function(mat,nbins)
{

    if (ncol(mat) != 2) stop("mat must be a 2 column matrix")
    x<-mat[,1]
    y<-mat[,2]
    x.cuts <- seq(from = min(x), to = max(x), length = nbins + 1,labels=F)

    y.cuts <- seq(from = max(y), to = min(y), length = nbins + 1,labels=F)
    adj<-adjacency_matrix(matrix(0,nbins,nbins))
    n=nbins-1
    heap<-rep(0,n)

    fill_heap<-function(i,field)
        {
            if (i<=n){

                ind<-(1+length(field))/2

                heap[i]<<-field[ind]
                fill_heap(2*i,field[1:ind])
                fill_heap(2*i+1,field[ind:length(field)])
            } else
            {

            }
        }


    fill_heap(1,x.cuts)
    heapx<-heap
    fill_heap(1,y.cuts)
    heapy<-heap

    return(list(x.cuts=x.cuts,y.cuts=y.cuts,adj=adj,nbins=nbins,heapx=heapx,heapy=heapy))
}



assign_pattern<-function(mat,pattern,clusterid,neib=FALSE,cut_level=3,depth=5,inf=1,scat=FALSE)
{
    x<-mat[,1]
    y<-mat[,2]

    y.cuts<-pattern$y.cuts
    x.cuts<-pattern$x.cuts
    index.x <- cut(x, x.cuts, include.lowest = TRUE,labels=F)
    index.y <- cut(-y, -y.cuts, include.lowest = TRUE,labels=F)
    nbins<-pattern$nbins
    m <- matrix(0, nrow = nbins, ncol = nbins)
    for (i in 1:length(index.x)) m[index.y[i], index.x[i]] <- m[index.y[i],
                                                                index.x[i]] + 1
    cutoff<-cut_level
    sel<-which(m>=cutoff,T)
    sel1<-which(m>=cutoff)


    assigned<-rep(0,nbins^2)
    ssx=NULL
    for (i in 1:length(sel[,1])){

        ssx=which(index.x==sel[i,2] & index.y==sel[i,1])

        if (length(unique(clusterid[ssx]))==1) assigned[sel1[i]]<-unique(clusterid[ssx])
    }

    dylka=1000000
    if (scat) choice=FALSE else choice=FALSE
    if (choice){
        vert<-NULL
        cluster<-assigned
        mat<-adjacency_matrix(matrix(0,nbins,nbins),0)
        for (i in sort(unique(cluster[which(cluster>0)]))){
            index_v<-which(cluster==i)
            m_ser<-mat$mat[which(cluster==i),which(cluster==i)]
            g_ser<-graph.adjacency(m_ser,mode="upper")
            V(g_ser)$index_v<-index_v
            comps <- decompose.graph(g_ser)

            l<-sapply(lapply(comps,V),length)
            l<-which(l==max(l))[1]
            vert<-c(vert,V(comps[[l]])$index_v)
        }

        cluster<-rep(0,nbins^2)
        cluster[vert]<-assigned[vert]
    } else cluster<-assigned



    if (neib) {

        mat<-adjacency_matrix(matrix(0,nbins,nbins),0)
        gr<-graph.adjacency(mat$mat,mode="upper")
        for (ord_i in 1:depth){
            for (i in unique(assigned[which(assigned>0)])){
                vertex<-which(cluster==i)-1

                sus<-NULL
                susp<-neighborhood(gr,ord_i,vertex)
                for (j in 1:length(susp)) sus<-c(sus,susp[[j]])
                sus<-unique(sus)+1

                sel<-sus[which(cluster[sus]<0)]

                cluster[sel]<--100000
                sel<-sus[which(cluster[sus]==0)]
                cluster[sel]<- -i
            }

            cluster[which(cluster==-100000)]<-0
            cluster[which(cluster<0)]<--cluster[which(cluster<0)]
        }


        assigned<-cluster
    }

    return(assigned)

}

create_template<-function(pattern,ass)
{
    return(list(assigned=ass,pattern$x.cuts,pattern$y.cuts,pattern$adj,
                pattern$nbins,heapx=pattern$heapx,heapy=pattern$heapy,
                lnb=log2(pattern$nbins)))
}

assign_events<-function(mat,template)
{
    cl<-rep(0,nrow(mat))
    res<-.C("assign_events2d",as.double(mat),as.integer(nrow(mat)),as.integer(2),
            as.double(template$heapx),as.double(template$heapy),as.integer(template$lnb),
            as.integer(template$assigned),cluster=as.integer(cl),PACKAGE="rgbeads")
    med=NULL
    for (i in unique(res$cluster[which(res$cluster>0)])){
        if (length(which(res$cluster==i))>1){
            med=rbind(med,apply(mat[which(res$cluster==i),],MARGIN=2,median))
        } else med<-rbind(med,mat[which(res$cluster==i),])
    }



    return(list(clusterid=res$cluster,med=med))

}
extract_median<-function(mat,clusterid,show=FALSE,def_perc=NULL,qc=FALSE,meanvar=FALSE,data=NULL,name=NULL,ass_cl=NULL,fcs_header=NULL)
{
    
    ## detekce modality nechana na puvodni verzi
    groups<-sort(unique(clusterid))
    groups<-groups[which(groups>0)]
    medians<-matrix(1,6,length(groups)) #zmeneno na 1 z -1 ale ne vsude, boze
    k=0

    for (i in groups){
        k=k+1
        group_sel<-mat[which(clusterid==i)]
        
        ## maxev<-160
        ## group_sel<-sample(group_sel,min(maxev,length(group_sel)))
        
        medians[1,k]<-median(group_sel)
        medians[2,k]<-i
        medians[3,k]<-length(group_sel)
        if (meanvar){
            medians[5,k]<-mean(group_sel)
            medians[6,k]<-var(group_sel)
        }
        if (qc){
            mat_res<-mat[which(clusterid==i)]
            if (length(mat_res)>2){

                dens<-density(log10(mat_res), n=16) ##bandwidth!!!!!!!!
                ## plot(mat[which(clusterid==i)])
                ## dens<-density(log10(mat[which(clusterid==i)]))
                ext_res<-extrema(dens$y)
                zc<-dens$y[ext_res$maxindex[,1]]
                

                
                zc<-zc/max(zc)
                if (length(zc)>1)if (sum(abs(zc))>4/3){
                    medians[4,k]<--1
                    ## aaaa<<-data[which(clusterid==i),]
                    ## fcs_header@exprs<-data[which(clusterid==i),]
                    ## fframe<-flowFrame(exprs=data[which(clusterid==i),],description=fcs_header@description)
                    ## write.FCS(x=fframe,file=paste("../../vysl/pop_",ass_cl,"_",k,"_",name,sep=""))
                }
                ## if (length(zc)>1){
                ##     max_c<-ext_res$maxindex[,1][which.max(zc)[1]]
                ##     minindex_c<-c(1,ext_res$minindex[,1],length(dens$x))
                ##     min_c<-c(max(minindex_c[minindex_c<=max_c]),min(minindex_c[minindex_c>=max_c]))
                
                ##     if (length(mat_res[log10(mat_res)>=dens$x[min_c[1]] & log10(mat_res)<=dens$x[min_c[2]]])/length(mat_res)<0.7 | abs(median(log10(mat_res))-dens$x[max_c])>0.15){
                ##         medians[4,k]<--1
                ##     }
                ## }
            } else medians[4,k]<--1
        }

    }

    if (show){

        for (i in groups){
                                        #            plot(hist(log10(mat[which(clusterid==i)]),breaks=64))
            plot(density(log10(mat[which(clusterid==i)]),width=1.2,n=16))
            print(i)
            print("dip")
            print(dip(mat[which(clusterid==i)]))
            print("nb:")
            print(length(mat[which(clusterid==i)]))
            print("median:")
            print(medians[i])
            print("zc:")
            print(medians[4,i])
            readline()
        }
    }


    return(medians)
}

enumerate<-function(med,struct,clusterid,switch=F)
{
    ## ## ## par(mfrow=c(2,1))
    ## ## plot(med)
    ## readline()
    ## ##  med<-t(solve(cov(med),t(med))) #test cislovani
    ## ## plot(med)
    
    coo=med
    coo_perm<-order(coo[,2],decreasing=T)
    dim1<-struct$base[1]
    dim2<-struct$base[2]
    missing<-struct$miss
    nb<-dim1*dim2-length(missing)
    index<-1:(dim1*dim2)
    wh<-NULL
    for (i in 1:length(index)) if (!(any(missing==i))) wh<-c(wh,i)
    if (!is.null(missing)) index<-index[wh]
    coo_perm_s<-rep(0,nb)
    last=0
    for (i in 1:dim2){
        if ((last+1)<(last+dim1-length(missing[which(missing>(i-1)*dim1 & missing<=i*dim1)]))){
            line=(last+1):(last+dim1-length(missing[which(missing>(i-1)*dim1 & missing<=i*dim1)]))
            last=max(line)} else {line=NULL
                                  last=0}
        sel=coo_perm[line]
        coo_perm_s[line]<-sel[order(coo[sel,1])]

    }

    cl_pom=clusterid
    wh<-list()[rep(length(unique(cl_pom)))]

    for (i in 1:nb){

                                        #        cl_pom[which(clusterid==coo_perm_s[i])]<-index[i]
        wh[[i]]<-which(clusterid==coo_perm_s[i])

    }
    for (i in 1:nb){
        cl_pom[wh[[i]]]<-index[i]
    }
    if (switch) return(list(clusterid=cl_pom,perm=coo_perm)) else return(clusterid=cl_pom)
}

                                        #---------------------------------------------------------------------


edit_structure<-function(struct=NULL)
{

    print("Name of Alexa647 or SSC:")
    name<-readline()
    print("Name of Ax750 or FSC:")
    name<-c(name,readline())
    struct$scatters$names<-name

    print("Was the first name a name of scatter? (if you type 'yes', negative values will be omitted)")
    name<-readline()
    print("Was the second name a name of scatter? (if you type 'yes', negative values will be omitted)")
    name<-c(name,readline())

    struct$scatters$def<-c(FALSE,FALSE)
    if (any(name=="yes")) struct$scatters$def[which(name=="yes")]<-TRUE
    print("Name of 1st alexa in Ax647/Ax488:")
    name<-readline()
    print("Name of 2nd alexa in Ax647/Ax488:")
    name<-c(name,readline())
    struct$alexas$names<-name

    print("Name of 1st pacific in Pacific Blue/Orange:")
    name<-readline()
    print("Name of 2nd pacific in Pacific Blue/Orange:")
    name<-c(name,readline())
    struct$pacific$names<-name

    print("Name of PE:")
    struct$pe<-readline()

    print("nb of populations in Alexa647 or SSC:")
    struct$scatters$ddiv1<-as.numeric(readline())

    print("nb of folowing populations (in Ax750 or FSC)")
    dd<-t(rep(0,struct$scatters$ddiv1))
    colnames(dd)<-1:struct$scatters$ddiv1
    dd<-as.vector(edit(as.data.frame(dd)))
    dd<-as.vector(t(dd[1,]))
    struct$scatters$ddiv2<-dd
    nbsz<-sum(dd)
    struct$beadsize<-rep("",nbsz)
    nbsz<-sum(dd)
    for (i in 1:nbsz){
        print("name of beads population in Ax750/Ax647 or SSC/FSC:")
        print(i)
        struct$beadsize[i]<-readline()

    }
    struct$alexas$struct<-list(list(base=NULL,miss=NULL))[rep(1:nbsz)]
    struct$pacific$struct<-list(list(base=NULL,miss=NULL,missd=NULL))[rep(1:nbsz)]

    print("define basic structure and missing population of alexas&pacifics")
    print("sizes are enumerated in ascending order")

    for (i in 1:nbsz){
        print(i)
        print("basic structure of Ax647/Ax488")
        print("Ax750/Ax647 (FSC/SSC) name:")
        print(struct$beadsize[i])
        dd<-t(rep(0,2))
        colnames(dd)<-struct$alexas$names
        dd<-as.vector(edit(as.data.frame(dd)))
        dd<-as.vector(t(dd[1,]))
        struct$alexas$struct[[i]]$base<-dd

        print("missing population in Ax647/Ax488")
        print("Ax750/Ax647 (FSC/SSC) name:")
        print(struct$beadsize[i])
        dd<-matrix(0,dd[1]*dd[2],1)
        dd<-as.vector(edit(as.data.frame(dd)))
        print(unique(dd))
        dd<-unique(dd)
        dd<-dd[which(dd>0),1]
        print(dd)
        if (length(dd)==0) dd<-NULL
        struct$alexas$struct[[i]]$miss<-dd
        print("basic structure of Pacific Blue/Orange")
        print("Ax750/Ax647 (FSC/SSC) name:")
        print(struct$beadsize[i])
        dd<-t(rep(0,2))
        colnames(dd)<-struct$pacific$names
        dd<-as.vector(edit(as.data.frame(dd)))
        dd<-as.vector(t(dd[1,]))
        struct$pacific$struct[[i]]$base<-dd

        print("missing population in Pacific Blue/Orange")
        print("Ax750/Ax647 (FSC/SSC) name:")
        print(struct$beadsize[i])
        nn<-dd[1]*dd[2]
        dd<-matrix(0,dd[1]*dd[2],1)

        dd<-as.vector(edit(as.data.frame(dd)))
        print(unique(dd))
        dd<-unique(dd)
        dd<-dd[which(dd>0),1]
        if (length(dd)==0) dd<-NULL

        struct$pacific$struct[[i]]$missd<-dd
        struct$pacific$struct[[i]]$miss<-matrix(0,nn+1,1)

    }



    frame<-list(gate_frame=list(struct=struct),template=NULL)
    return(frame)
}

gate_pop<-function(mat_loc,struct_pac,i,alex_loc,names)
{

    stid=which(struct_pac$miss[1,]==i)

    if (length(stid)==1) {
        pacific_s<-list(base=struct_pac$base,
                        miss=struct_pac$miss[2:nrow(struct_pac$miss),stid])
        pacific_s$miss<-pacific_s$miss[which(pacific_s$miss>0)]
    }else{
        pacific_s<-list(base=struct_pac$base,miss=struct_pac$missd)
    }

    nbpop=pacific_s$base[1]*pacific_s$base[2]-length(pacific_s$miss)
    clf<-cluster_kmedoids(mat_loc[which(alex_loc==i),names],nbpop,show=F,id=i)
    coo<-clf$med
    clf$clusterid<-enumerate(clf$med,pacific_s,clf$clusterid)
    return(list(cluster=clf$clusterid,med=coo))
}

line_plot<-function(matrix=NULL,nb_fr=24,filepdf="lineplot.pdf",popnames=NULL,log=TRUE,fixed,nogrid,mininfo=NULL,qc_data=NULL,peaks=NULL)
{
    xmat<-rep(c(1:nb_fr),ncol(matrix)%/%nb_fr)
    nblines<-ncol(matrix)%/%nb_fr
    xmat<-matrix(xmat,nb_fr,ncol(matrix)%/%nb_fr)
    if (is.null(matrix)) stop()
                                        #    sel<-find_diff_plot(matrix)
    if (is.null(popnames)) index<-1:nrow(matrix) else index<-substr(popnames[,2],1,19)
    ord<-index
    nr<-nrow(matrix)
    if (!is.null(popnames)){
        ord<-order(index)
        index<-index[ord]
        matrix<-matrix[ord,]
        qc_data<-qc_data[c(ord,nr+ord),]
        peaks<-peaks[ord,]
    }
                                        #    matrix<-matrix[sel,]
                                        #     maxlevel=max(matrix)
                                        #     if(log) maxlevel=log10(maxlevel)
                                        #    index<-index[sel]
    pdf(filepdf,paper="USr",width=0,height=0)
    if (!is.null(mininfo)){

        color_text<-matrix(1,nrow(mininfo$table),ncol(mininfo$table))
        cex_text<-matrix(0.5,nrow(mininfo$table),ncol(mininfo$table))
        barv<-rainbow(max(nblines,8))
        if (length(barv)>=4) barv[4]<-"#000000FF"

        for (i in (7:(7+nblines-1))){
            ss<-(ncol(mininfo$table)-1):ncol(mininfo$table)
            
            color_text[i,ss]<-barv[i-6]
            cex_text[i,ss]<-0.7
        }
        par(mfrow=c(1,1),mar=c(0,0,0,0))
        plot(0,xlim=c(0,8),ylim=c(0,45),xlab="",ylab="",type="n")
        for (i in 1:nrow(mininfo$table)){
            for(j in 1:ncol(mininfo$table)){
                text(j,45-i,mininfo$table[i,j],cex=cex_text[i,j],col=color_text[i,j],pos=3)
            }
        }


    }
    
    if (!is.null(qc_data)){
        if (is.null(mininfo)){
            par(mfrow=c(1,1),mar=c(0,0,0,0))
            plot(0,xlim=c(0,8),ylim=c(0,45),xlab="",ylab="",type="n")
        }
        points(1,30,pch=3)
        text(2,30,"less then 10 events")
        points(1,29,pch=2)
        text(2,29,"less then 8 events")
        points(1,28,pch=1)
        text(2,28,"less then 5 events")
        points(1,27,pch=5)
        text(2,27,"multimodal PE signal")
    }


    par(mfrow=c(5,6),mai=c(0.3,0.3,0.2,0.02),cex.main=0.80,ylog=TRUE)
    barv<-rainbow(max(nblines,8))
    if (length(barv)>=4) barv[4]<-"#000000FF"
    matplot(t(matrix(rep(1:nb_fr,nblines),nrow=nblines,byrow=T)),t(matrix(rep(nblines:1,nb_fr),nrow=nblines,byrow=F)),type="l",lwd=1,lty=1,main="legend",xlab="",ylim=c(0,2*nblines-2),col=barv,ylab="",axes=F)
                                        #   axis(1,at= seq(from=1,to=nb_fr,by=1),labels=F)
                                        #   axis(2,at=NULL)

    legend(0,2*nblines-2,c(1:nblines),col=barv, lty=1, ncol = 3, cex = 0.8)
    for (i in 1:nrow(matrix)){
        ymat<-matrix[i,]

        ymat[which(ymat<1)]<-1
        if (log) ymat<-log10(ymat)
        ymat<-matrix(ymat,nb_fr,ncol(matrix)%/%nb_fr)
                                        #        ymatshrinked<-t(apply(ymat,as.numeric,MARGIN=1))
                                        #        ymax<-max(ymatshrinked)
                                        #        ymatshrinked<-apply(ymatshrinked,wavShrink,MARGIN=2,threshold=ymax/7)

        if (fixed & log) {
            matplot(xmat,ymat,type="l",lwd=1,lty=1,main=paste(index[i],sep="  ","|",ord[i],"|"),xlab="",ylim=c(0,5),col=barv)
                                        #           matplot(xmat,ymatshrinked,type="l",lwd=1,lty=1,main=paste(index[i],sep="  ","|",ord[i],"|sh"),xlab="",
                                        #                                                     ylim=NULL,col=barv)
        } else
        {
            matplot(xmat,ymat,type="l",lwd=1,lty=1,main=paste(index[i],sep="  ","|",ord[i],"|"),xlab="",
                    ylim=NULL,col=barv)
                                        #           matplot(xmat,ymatshrinked,type="l",lwd=1,lty=1,main=paste(index[i],sep="  ","|",ord[i],"sh|"),xlab="",
                                        #                                  ylim=NULL,col=barv)
        }

        if (!is.null(qc_data)){
            pop_mat<-matrix(qc_data[i,],nb_fr,ncol(matrix)%/%nb_fr)

            for (j in (1:ncol(pop_mat))){

                for (k in 1:nb_fr) if (pop_mat[k,j]<5) points(xmat[k,j],ymat[k,j],pch=1,col=barv[j])
                else if (pop_mat[k,j]<8) points(xmat[k,j],ymat[k,j],pch=2,col=barv[j]) #text(xmat[k,j],ymat[k,j],as.character(pop_mat[k,j]),cex=0.7,col=barv[j],offset=0)
                else if (pop_mat[k,j]<10) points(xmat[k,j],ymat[k,j],pch=3,col=barv[j])
                
            }
            if (nrow(qc_data)>nrow(matrix)){
                pop_mat<-matrix(qc_data[(i+nrow(matrix)),],nb_fr,ncol(matrix)%/%nb_fr)

                for (j in (1:ncol(pop_mat))){
                    for (k in 1:nb_fr) if (pop_mat[k,j]<0) points(xmat[k,j],ymat[k,j],pch=5,col=barv[j])
                }
            }
        }
        
        if (!is.null(peaks)){
            peaks_mat<-matrix(peaks[i,],nb_fr,ncol(matrix)%/%nb_fr)
            ## print(peaks_mat)
            ## readline()
            for (j in (1:ncol(peaks_mat)))
                for (k in 1:nb_fr) if (peaks_mat[k,j]!=0) points(xmat[k,j],ymat[k,j],pch=abs(peaks_mat[k,j]),col=barv[j],cex=0.7)
            
        }
        axis(1,at= seq(from=1,to=nb_fr,by=1),labels=F)
                                        #        grid(lty=1,lwd=0.2)
        if (!nogrid) abline(v=1:nb_fr,lwd=0.2,col="lightgrey")
        abline(h=axTicks(side=2),lwd=0.2,col="lightgrey")
    }
    par(mfrow=c(1,1))
    dev.off()



}



read_mininfo<-function(path)
{
    mininfo<-read.table(path,sep="\t",fill=T,stringsAsFactors=F)
    if (nrow(mininfo)>13 | ncol(mininfo)>3 ) mininfo<-mininfo[1:14,1:4] else mininfo<-mininfo[1:12,1:2]
    if (any(is.na(mininfo))) print("warning: blank cells in mininfo table")
    if (ncol(mininfo)==2){
        desc<-rep("",12)
       
        desc<-mininfo[,2]
         names(desc)<-c("exp","date","project_name","note","prep_method","fractions","sample_1","sample_2","sample_3","sample_4","array","pltID")
    } else
    {
         desc<-rep("",12)
        names(desc)<-c("exp","date","project_name","note","prep_method","fractions","sample_1","sample_2","sample_3","sample_4","array","pltID")
         
         desc<-mininfo[-c(12,13),4]
         names(desc)<-c("exp","date","project_name","note","prep_method","fractions","sample_1","sample_2","sample_3","sample_4","array","pltID")
    }
    
    return(list(table=mininfo,desc=desc))
}


create_splitting_frame<-function(fcsfiles,channels,splitnames=NULL,depth=6,scatters=F,gateframes=NULL)
{
    if (length(channels)!=2) stop("2-dim split only")
    if (!is.null(splitnames) & (length(fcsfiles)!=length(splitnames))) stop("bad splitnames number")
    if(!is.null(gateframes) & (length(fcsfiles)!=length(gateframes))) stop("nad gateframes number")
    fil_nb<-length(fcsfiles)
    scat_cl<-NULL
    data<-NULL
    if (fil_nb>1){
        for (i in 1:fil_nb){
            serv<-read.FCS(fcsfiles[i])
            
            if (!is.null(serv@description$SPILL)) serv<-compensate(serv,spillover=serv@description$SPILL) ## POZOR!!!

            serv<-serv@exprs
            scat_cl<-c(scat_cl,rep(i,nrow(serv)))

            data<-rbind(data,serv)

        }
    }
    if (scatters) dept<-1
    if(!scatters) data[data<0]<--1*data[data<0] else data[data<0]<-0
    if (!scatters) data<-log10(data+1000.0)
    if (is.null(splitnames)) splitnames<-as.character(1:fil_nb)
    splitframe<-list(data=data,template=NULL,names=channels,nb=fil_nb,splitnames=splitnames,gateframes=gateframes,scatters=scatters)

    pattern<-create_pattern(mat=data[,channels],nbins=64)
    assign<-assign_pattern(mat=data[,channels],pattern=pattern,neib=TRUE,clusterid=scat_cl,cut_level=3,depth=depth,scat=TRUE)
    splitframe$template<-list(pat=pattern,ass=assign)
    
    return(splitframe)
}

split_fcs<-function(file=NULL,directory=NULL,splitframe=NULL,destination=".",splitnames=NULL)
    {
        scatters<-splitframe$scatters
        if (!is.null(splitnames) & (length(splitnames)!=length(splitframe$splitnames))) stop("Bad splitnames dim")
        if (is.null(splitnames)) splitnames<-splitframe$splitnames
        
        if (is.null(splitframe)) stop("No frame")
        if (all(is.null(c(file,directory)))) stop("No target")
        
        if (!is.null(directory)) file<-system(paste("ls ", directory, "*.fcs",sep=""),intern=T)
        
        a<-"mkdir "
        for (i in splitnames){
            a<-paste(a,paste(destination,"/",i,sep=""),sep=" ")
        }
        system(a)
        
        
        temp<-create_template(ass=splitframe$template$ass, pattern= splitframe$template$pat)
        
        for (i in file){
            print(i)
            fcs<-read.FCS(i)
            if (!is.null(serv@description$SPILL)) fcs<-compensate(serv,spillover=fcs@description$SPILL) ## POZOR!!!
            data<-fcs@exprs
            
            if(!scatters) data[data<0]<--1*data[data<0] else data[data<0]<-0
            if (!scatters) data<-log10(data+1000.0)
            scat_cl<-assign_events(mat=data[,splitframe$names],template=temp)$clusterid
            
            
            
            for (j in unique(scat_cl[scat_cl>0])){
                flfrm<-fcs[which(scat_cl==j),]
                nd<-nchar(directory)
                
                write.FCS(x=flfrm,filename=paste(destination,"/",splitnames[j],"/",paste(splitnames[j],substr(i,nd+1,nchar(i)),sep="_"),sep=""))
            }
            
        }
        
    }

                                        #ukradeno z balicku EMD
extrema<-function (y, ndata = length(y), ndatam1 = ndata - 1)
{
    minindex <- maxindex <- NULL
    nextreme <- 0
    cross <- NULL
    ncross <- 0
    z1 <- sign(diff(y))
    index1 <- seq(1, ndatam1)[z1 != 0]
    z1 <- z1[z1 != 0]
    if (!(is.null(index1) || all(z1 == 1) || all(z1 == -1))) {
        index1 <- index1[c(z1[-length(z1)] != z1[-1], FALSE)] +
            1
        z1 <- z1[c(z1[-length(z1)] != z1[-1], FALSE)]
        nextreme <- length(index1)
        if (nextreme >= 2)
            for (i in 1:(nextreme - 1)) {
                tmpindex <- index1[i]:(index1[i + 1] - 1)
                if (z1[i] > 0) {
                    tmpindex <- tmpindex[y[index1[i]] == y[tmpindex]]
                    maxindex <- rbind(maxindex, c(min(tmpindex),
                                                  max(tmpindex)))
                }
                else {
                    tmpindex <- tmpindex[y[index1[i]] == y[tmpindex]]
                    minindex <- rbind(minindex, c(min(tmpindex),
                                                  max(tmpindex)))
                }
            }
        tmpindex <- index1[nextreme]:ndatam1
        if (z1[nextreme] > 0) {
            tmpindex <- tmpindex[y[index1[nextreme]] == y[tmpindex]]
            maxindex <- rbind(maxindex, c(min(tmpindex), max(tmpindex)))
        }
        else {
            tmpindex <- tmpindex[y[index1[nextreme]] == y[tmpindex]]
            minindex <- rbind(minindex, c(min(tmpindex), max(tmpindex)))
        }
        if (!(all(sign(y) >= 0) || all(sign(y) <= 0) || all(sign(y) ==
                                             0))) {
            index1 <- c(1, index1)
            for (i in 1:nextreme) {
                if (y[index1[i]] == 0) {
                    tmp <- c(index1[i]:index1[i + 1])[y[index1[i]:index1[i +
                                                                         1]] == 0]
                    cross <- rbind(cross, c(min(tmp), max(tmp)))
                }
                else if (y[index1[i]] * y[index1[i + 1]] < 0) {
                    tmp <- min(c(index1[i]:index1[i + 1])[y[index1[i]] *
                                                          y[index1[i]:index1[i + 1]] <= 0])
                    if (y[tmp] == 0) {
                        tmp <- c(tmp:index1[i + 1])[y[tmp:index1[i +
                                                                 1]] == 0]
                        cross <- rbind(cross, c(min(tmp), max(tmp)))
                    }
                    else cross <- rbind(cross, c(tmp - 1, tmp))
                }
            }
            if (any(y[index1[nextreme + 1]] * y[index1[nextreme +
                                                       1]:ndata] <= 0)) {
                tmp <- min(c(index1[nextreme + 1]:ndata)[y[index1[nextreme +
                                                                  1]] * y[index1[nextreme + 1]:ndata] <= 0])
                if (y[tmp] == 0) {
                    tmp <- c(tmp:ndata)[y[tmp:ndata] == 0]
                    cross <- rbind(cross, c(min(tmp), max(tmp)))
                }
                else cross <- rbind(cross, c(tmp - 1, tmp))
            }
            ncross <- nrow(cross)
        }
    }
    list(minindex = minindex, maxindex = maxindex, nextreme = nextreme,
         cross = cross, ncross = ncross)
}
                                        #konec kradeze



