\name{apply_gate_template}
\alias{apply_gate_template}
\title{Batch gating and storing results}
\description{
  Applies the frame to analyze experiment
}
\usage{
         apply_gate_template(directory, experiment_destination,...)
          }
\arguments{
  \item{directory}{a character string giving the
    path to folder containing the experiment. Used in this way, the
    directory must exist and contain all fcs files, minimal
    array info text file, and the frame. For other ways of using this
    function consult user manual}
  \item{experiment_destination}{a character string giving the
    path to folder, where the experiment folder structure is going to be
    created. The folder experiment_destination must exist. If omitted cunrent working
    directory is used.}
  \item{...}{Other arguments described in user manual}
}
\seealso{
  
}
\examples{
##to run this example you need to visit site
##www.bioinformin.net/sample.php a download data sample in decribed way.
library(rgbeads)
##Now load the prepared frame.
load("archframe")
## This frame is result of the function edit_structure() and contains only description of structure of the array.
## Now we add to this frame information about population distribution in the training file(s).
array6558<-create_gate_frame(frame=archframe,inputfile=c("1ST_C1_C01_LOW.fcs","1ST_C1_C01_HIGH.fcs"),popdesc="array6558.txt")
##Now we need to inspect this frame and add to it the spatial template for rapid batch gating.
array6558<-inspect_gate_frame(array6558)
##When you have checked all population, type ”finish” (enter), and wait a while, while template is being
##created.
##The frame is now completed, it contains all information (structure of array, missing population, spatial template)
##and we can save it!
save(array6558, file="./exp_source/array6558")
##And now eventually we can extract the medians!
##check if the directory ./exp_source exists and contains all necessary files
apply_gate_template(directory="./exp_source")

        
          }


