\name{create_gate_frame}
\alias{create_gate_frame}
\title{Population recognition}
\description{
 Identifies population with respect to array definition
}
\usage{
create_gate_frame(frame,inputfile,popdesc)
          }
\arguments{
  \item{frame}{array description - result of the function edit_structure}
  \item{inputfile}{character string or vector providing path to fcs
    file(s). If vector the fcs files are taken as manual definition of
    the population on first level. See user manual}
  \item{popdesc}{character string - path to the file containing names of
  antibodies of each population}
 
}
\value{named list containing array description, training dataset,
  population description and cluster assignement
 
}

\details{function recognize populations with respect to array definition
a name them (using information in popdesc). The recognition is based on
modified PAM algoritm}
\examples{
##to run this example you need to visit site
##www.bioinformin.net/sample.php a download data sample in decribed way.
library(rgbeads)
##Now load the prepared frame.
load("archframe")
## This frame is result of the function edit_structure() and contains only description of structure of the array.
## Now we add to this frame information about population distribution in the training file(s).
array6558<-create_gate_frame(frame=archframe,inputfile=c("1ST_C1_C01_LOW.fcs","1ST_C1_C01_HIGH.fcs"),popdesc="array6558.txt")
##Now we need to inspect this frame and add to it the spatial template for rapid batch gating.
array6558<-inspect_gate_frame(array6558)
##When you have checked all population, type ”finish” (enter), and wait a while, while template is being
##created.
##The frame is now completed, it contains all information (structure of array, missing population, spatial template)
##and we can save it!
save(array6558, file="./exp_source/array6558")
##And now eventually we can extract the medians!
##check if the directory ./exp_source exists and contains all necessary files
apply_gate_template(directory="./exp_source")

        
 }
