#include <time.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
#include <limits.h>
#include <string.h>
#include "beads.h"

void nbnonzero(int *nn, int *mm, int *k,int* hash,int *mode)
{
  int n=*nn;
  int m=*mm;
  int nbV=m*n;
  int i,j,kk=*k;

    
  for (i=0;i<nbV;i++){
    hash[i]=i+1;
  }


  for (i=0;i<n;i++){
    for (j=0;j<m;j++){
      hash[nbV+i*m+j]=j+1;
      hash[2*nbV+i*m+j]=i+1;
    }
  }

  
  int nbNz=0;
  kk=0;
  if (*mode==1){
    for (i=0;i<nbV;i++){
      for (j=0;j<nbV;j++){
        if ((abs(hash[nbV+i]-hash[nbV+j])<=1) && (abs(hash[2*nbV+i]-hash[2*nbV+j])<=1)){
          kk++;
        }
      }
    }
    *k=kk;
  }
  else
    {
      for (i=0;i<nbV;i++){
        for (j=0;j<nbV;j++){
          if (((abs(hash[nbV+i]-hash[nbV+j])<=1) && (abs(hash[2*nbV+i]-hash[2*nbV+j])<1)) ||
              ((abs(hash[nbV+i]-hash[nbV+j])<1) && (abs(hash[2*nbV+i]-hash[2*nbV+j])<=1))){
            kk++;
          }
        }
      }
      *k=kk;

    }
}


void nonzero(int *ii, int *jj, int *nn, int *mm, int *hash,int *mode)
{
  int n=*nn;
  int m=*mm;
  int nbV=m*n;
  int i,j,k;


  int nbNz=0;

  k=0;
    
  if (*mode==1){
    for (i=0;i<nbV;i++){
      for (j=0;j<nbV;j++){
        if ((abs(hash[nbV+i]-hash[nbV+j])<=1) && (abs(hash[2*nbV+i]-hash[2*nbV+j])<=1)){
          ii[k]=i+1;
          jj[k]=j+1;
          k++;
        }
      }
    }
  }
  else
    {
      for (i=0;i<nbV;i++){
        for (j=0;j<nbV;j++){
          if (((abs(hash[nbV+i]-hash[nbV+j])<=1) && (abs(hash[2*nbV+i]-hash[2*nbV+j])<1)) || 
              ((abs(hash[nbV+i]-hash[nbV+j])<1) && (abs(hash[2*nbV+i]-hash[2*nbV+j])<=1))){
            ii[k]=i+1;
            jj[k]=j+1;
            k++;
          }
        }
      }
    

    }

}

void transform(double *mat,int *nbev, int *nbdim,double *plus){
  int n=*nbev;
  int m=*nbdim;
  int pl=*plus;
  int i,j;

  for (i=0;i<n;i++){
    for (j=0;j<m;j++){
      mat[j*n+i]=log(mat[j*n+i]+pl);
    }
  }
}

void assign_nearest(double *mat,int *nbev, int *nbdim,double *medoids, int *nbcl,int *cluster){
  int n=*nbev;
  int m=*nbdim;
  int nbc=*nbcl;
  int i,j,k;
  double dist,d;
  int index;
    
  for (i=0;i<n;i++){
    dist=10000.;
    for (k=0;k<nbc;k++){
      d=0.;
      for (j=0;j<m;j++){
        d=d+(mat[j*n+i]-medoids[j*nbc+k])*(mat[j*n+i]-medoids[j*nbc+k]);
      }
      if (d<dist){
        dist=d;
        index=k;
      }
    }
    cluster[i]=index;
  }
}

void assign_nearest_s(double *mat,int *nbev, int *nbdim,double *sample, int *samplesize,int *isample,int *cluster){
  int n=*nbev;
  int m=*nbdim;
  int nbc=*samplesize;
  int i,j,k;
  double dist,d;
  int index;
    
  for (i=0;i<n;i++){
    dist=10000.;
    for (k=0;k<nbc;k++){
      d=0.;
      for (j=0;j<m;j++){
        d=d+(mat[j*n+i]-sample[j*nbc+k])*(mat[j*n+i]-sample[j*nbc+k]);
      }
      if (d<dist){
        dist=d;
        index=isample[k];
      }
    }
    cluster[i]=index;
  }
}



void assign_events2d(double *mat,int *nbev, int *nbdim,double *heapx, double *heapy, int *lnbinnum,int *ass_pattern,int *cluster){
  int n=*nbev;
  int m=*nbdim;
  int comp=*lnbinnum;
  int change= (int) pow(2,comp);
  double event[m-1];
  int i,j,lev,row,col,nod,ass;


  for (i=0;i<n;i++){
    for (j=0;j<m;j++){
      event[j]=mat[i+n*j];
    }


    nod=1;
    lev=1;
    while (lev<=comp){

      if (event[0]<heapx[nod-1]) 
        nod=2*nod;
      else
        nod=2*nod+1;
      lev++;
    }
    col=nod-change+1;

    nod=1;
    lev=1;
    while (lev<=comp){
      if (event[1]<heapy[nod-1])
        nod=2*nod+1;
      else
        nod=2*nod;
      lev++;
    }

    row=nod-(int) change +1;
    ass=(col-1)*change+row-1;

    cluster[i]=ass_pattern[ass];
  }

}

void apply_trans(double *mat, double *matt, int *nb_prot, int* nb_frac,double *trans, int *nd){
  int nr=*nb_prot;
  int nc=*nb_frac;
  int ndeg=*nd;
  int i,j,d;
  for (i=0;i<nr;i++){
    for (j=0;j<nc;j++){
      for (d=0;d<ndeg;d++)  matt[j*nr+i]=pow(mat[j*nr+i],ndeg-1.-d)*trans[j*ndeg+d]+matt[j*nr+i];
    }
  }

}

